<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_79) on Sun Feb 12 09:57:45 AST 2017 -->
<title>LinkedListDeque</title>
<meta name="date" content="2017-02-12">
<link rel="stylesheet" type="text/css" href="../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="LinkedListDeque";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/LinkedListDeque.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../Queue/ArrayDeque.html" title="class in Queue"><span class="strong">Prev Class</span></a></li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../index.html?Queue/LinkedListDeque.html" target="_top">Frames</a></li>
<li><a href="LinkedListDeque.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">Queue</div>
<h2 title="Class LinkedListDeque" class="title">Class LinkedListDeque&lt;E&gt;</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>Queue.LinkedListDeque&lt;E&gt;</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>E</code> - Data type of elements in the collection</dd></dl>
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;E&gt;</dd>
</dl>
<hr>
<br>
<pre>public class <span class="strong">LinkedListDeque&lt;E&gt;</span>
extends java.lang.Object
implements <a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;E&gt;</pre>
<div class="block">This Generic class implements Deque interface and contains various methods for manipulating Deque using Generic Array (such as
 two way insert and delete).
 <p>
 Implementation of Deque may have following Special Case
 <ul>
 <li>First Element Insertion - Both Front and Rear points to same node
 <li>Empty Array - Denoted by size zero
 <li>When Rear and Front pointer points to same index it implies list has only one value
 </ul>
 <p>
 Assumptions/Restrictions: User inputs valid single dimension array of allowable length
 <p>
 Noteworthy Features: 
 <ul>
 <li>Generic Implementation of linked list
 <li>Tested using Junit for various scenarios 
 </ul></div>
<dl><dt><span class="strong">Author:</span></dt>
  <dd>Asok Kalidass Kalisamy (B00763356) - Graduate Student</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../Queue/LinkedListDeque.html#LinkedListDeque()">LinkedListDeque</a></strong>()</code>
<div class="block">Initializes an Linked Lists</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a></code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#firstElement()">firstElement</a></strong>()</code>
<div class="block">Returns First element of deque</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#insertFirst(E)">insertFirst</a></strong>(<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&nbsp;element)</code>
<div class="block">Inserts an element at front of deque</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#insertLast(E)">insertLast</a></strong>(<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&nbsp;element)</code>
<div class="block">Inserts an element at rear end of the deque</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#isEmpty()">isEmpty</a></strong>()</code>
<div class="block">Checks for an empty array</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a></code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#lastElement()">lastElement</a></strong>()</code>
<div class="block">Returns last element of deque</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#readQueue()">readQueue</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a></code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#removeFirst()">removeFirst</a></strong>()</code>
<div class="block">Remove an element from front of deque</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a></code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#removeLast()">removeLast</a></strong>()</code>
<div class="block">Remove an element from front of deque</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#size()">size</a></strong>()</code>
<div class="block">Returns the size of an array</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../Queue/LinkedListDeque.html#toString()">toString</a></strong>()</code>
<div class="block">Returns the node content</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>equals, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="LinkedListDeque()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>LinkedListDeque</h4>
<pre>public&nbsp;LinkedListDeque()</pre>
<div class="block">Initializes an Linked Lists</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>maxSize</code> - </dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="size()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>size</h4>
<pre>public&nbsp;int&nbsp;size()</pre>
<div class="block">Returns the size of an array</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../Interface/Deque.html#size()">size</a></code>&nbsp;in interface&nbsp;<code><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&gt;</code></dd>
<dt><span class="strong">Returns:</span></dt><dd>Returns the size of an array</dd></dl>
</li>
</ul>
<a name="isEmpty()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isEmpty</h4>
<pre>public&nbsp;boolean&nbsp;isEmpty()</pre>
<div class="block">Checks for an empty array</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../Interface/Deque.html#isEmpty()">isEmpty</a></code>&nbsp;in interface&nbsp;<code><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&gt;</code></dd>
<dt><span class="strong">Returns:</span></dt><dd>True - if empty else false</dd></dl>
</li>
</ul>
<a name="insertFirst(java.lang.Object)">
<!--   -->
</a><a name="insertFirst(E)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>insertFirst</h4>
<pre>public&nbsp;void&nbsp;insertFirst(<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&nbsp;element)</pre>
<div class="block">Inserts an element at front of deque</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../Interface/Deque.html#insertFirst(E)">insertFirst</a></code>&nbsp;in interface&nbsp;<code><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&gt;</code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>element</code> - - data to be added</dd></dl>
</li>
</ul>
<a name="insertLast(java.lang.Object)">
<!--   -->
</a><a name="insertLast(E)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>insertLast</h4>
<pre>public&nbsp;void&nbsp;insertLast(<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&nbsp;element)</pre>
<div class="block">Inserts an element at rear end of the deque</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../Interface/Deque.html#insertLast(E)">insertLast</a></code>&nbsp;in interface&nbsp;<code><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&gt;</code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>element</code> - - data to be added</dd></dl>
</li>
</ul>
<a name="removeFirst()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeFirst</h4>
<pre>public&nbsp;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&nbsp;removeFirst()
              throws <a href="../Exceptions/EmptyStructureException.html" title="class in Exceptions">EmptyStructureException</a></pre>
<div class="block">Remove an element from front of deque</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../Interface/Deque.html#removeFirst()">removeFirst</a></code>&nbsp;in interface&nbsp;<code><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&gt;</code></dd>
<dt><span class="strong">Returns:</span></dt><dd>element that was removed</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../Exceptions/EmptyStructureException.html" title="class in Exceptions">EmptyStructureException</a></code> - when array index has no empty</dd></dl>
</li>
</ul>
<a name="removeLast()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeLast</h4>
<pre>public&nbsp;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&nbsp;removeLast()
             throws <a href="../Exceptions/EmptyStructureException.html" title="class in Exceptions">EmptyStructureException</a></pre>
<div class="block">Remove an element from front of deque</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../Interface/Deque.html#removeLast()">removeLast</a></code>&nbsp;in interface&nbsp;<code><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&gt;</code></dd>
<dt><span class="strong">Returns:</span></dt><dd>element that was removed</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../Exceptions/EmptyStructureException.html" title="class in Exceptions">EmptyStructureException</a></code> - when array index has no empty</dd></dl>
</li>
</ul>
<a name="toString()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>toString</h4>
<pre>public&nbsp;java.lang.String&nbsp;toString()</pre>
<div class="block">Returns the node content</div>
<dl>
<dt><strong>Overrides:</strong></dt>
<dd><code>toString</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
<dt><span class="strong">Returns:</span></dt><dd>Returns the node content</dd></dl>
</li>
</ul>
<a name="firstElement()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>firstElement</h4>
<pre>public&nbsp;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&nbsp;firstElement()
               throws <a href="../Exceptions/EmptyStructureException.html" title="class in Exceptions">EmptyStructureException</a></pre>
<div class="block">Returns First element of deque</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../Interface/Deque.html#firstElement()">firstElement</a></code>&nbsp;in interface&nbsp;<code><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&gt;</code></dd>
<dt><span class="strong">Returns:</span></dt><dd>Return First element of deque</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../Exceptions/EmptyStructureException.html" title="class in Exceptions">EmptyStructureException</a></code></dd></dl>
</li>
</ul>
<a name="lastElement()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>lastElement</h4>
<pre>public&nbsp;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&nbsp;lastElement()
              throws <a href="../Exceptions/EmptyStructureException.html" title="class in Exceptions">EmptyStructureException</a></pre>
<div class="block">Returns last element of deque</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../Interface/Deque.html#lastElement()">lastElement</a></code>&nbsp;in interface&nbsp;<code><a href="../Interface/Deque.html" title="interface in Interface">Deque</a>&lt;<a href="../Queue/LinkedListDeque.html" title="type parameter in LinkedListDeque">E</a>&gt;</code></dd>
<dt><span class="strong">Returns:</span></dt><dd>Return last element of deque</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../Exceptions/EmptyStructureException.html" title="class in Exceptions">EmptyStructureException</a></code></dd></dl>
</li>
</ul>
<a name="readQueue()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>readQueue</h4>
<pre>public&nbsp;java.lang.String&nbsp;readQueue()</pre>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/LinkedListDeque.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../deprecated-list.html">Deprecated</a></li>
<li><a href="../index-files/index-1.html">Index</a></li>
<li><a href="../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../Queue/ArrayDeque.html" title="class in Queue"><span class="strong">Prev Class</span></a></li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../index.html?Queue/LinkedListDeque.html" target="_top">Frames</a></li>
<li><a href="LinkedListDeque.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
